import {
  IdField,
  IntFilter,
  StringFilter,
  TKeyFieldType,
} from '../buildedTypes'
import BaseFieldBuilder from './BaseFieldBuilder'

class IdFieldBuilder extends BaseFieldBuilder {
  type: TKeyFieldType = 'int'
  autoGenerated = true
  constructor(name: string, defaultLanguage: string, title?: string) {
    super(name, defaultLanguage, title)
    this.required = true
    this.updateDefaultDbValue()
  }

  setType(type: TKeyFieldType) {
    this.type = type

    if (this.type === 'string') {
      this.setAutoGenerated(false)
    }

    this.updateDefaultDbValue()

    return this
  }

  build(): IdField {
    const base = super.build()

    if (this.type === 'bigint' || this.type === 'int') {
      return {
        ...base,
        autoGenerated: this.autoGenerated,
        category: 'id',
        // constantOnCreate: this.constantOnCreate as ConstantOnCreateInt,
        // constantOnUpdate: this.constantOnUpdate as ConstantOnUpdateInt,
        type: this.type,
        title: this.title,
        showInList: this.showInList,
        showInCreate: this.showInCreate,
        showInEdit: this.showInEdit,
        showInFilter: this.showInFilter,
        defaultDbValue: this.defaultDbValue,
        filters: this.filters as IntFilter[],
        numberType: this.numberType
      }
    } else if (this.type === 'string') {
      return {
        ...base,
        autoGenerated: this.autoGenerated,
        category: 'id',
        type: this.type,
        title: this.title,
        showInList: this.showInList,
        showInCreate: this.showInCreate,
        showInEdit: this.showInEdit,
        showInFilter: this.showInFilter,
        defaultDbValue: this.defaultDbValue,
        stringType: this.stringType,
        filters: this.filters as StringFilter[],
      }
    }

    throw new Error(`Unexpected type: ${this.type}`)
  }
  setAutoGenerated(autoGenerated = true) {
    this.setRequiredOnInput(!autoGenerated)
    this.autoGenerated = autoGenerated
    this.updateDefaultDbValue()
    if (!autoGenerated) {
      this.defaultDbValue = undefined
    }

    return this
  }
  private updateDefaultDbValue() {
    if (this.autoGenerated) {
      if (this.type === 'bigint' || this.type === 'int') {
        this.defaultDbValue = 'autoincrement()'
      } else {
        this.defaultDbValue = 'cuid()'
      }
    }

    return this
  }
  setNotAutoGenerated() {
    this.autoGenerated = false

    return this
  }
}

export default IdFieldBuilder;
